#!/bin/bash

# Current dir
_ME=$(readlink -f "$0")
PWD=$(dirname "${_ME}")
EDBVERSION=

# Config name
[ -f ${PWD}/.configure ] && CONFIG=$(cat ${PWD}/.configure | tr -d "\n\r")
CONFIG=${CONFIG:-default}

# Configs
source "${PWD}/config/${CONFIG}.config"

export PGPORT=$PGCLUSTERPORT
export PGPASSWORD=postgres

psql -h $PGCLUSTERHOST -p $PGCLUSTERPORT -c "select pg_terminate_backend(pg_stat_activity.pid) \
	from pg_stat_activity \
	where pg_stat_activity.datname = '$1' \
	and pid <> pg_backend_pid(); \
	update pg_database set datallowconn = 'false' where datname = '$1';" postgres postgres && \
dropdb --if-exists -h $PGCLUSTERHOST -p $PGCLUSTERPORT -U postgres $1	

