start transaction;

\cd :_TMP
\i vars.psql

\cd :_DIR
\i globals.psql
\i langs.psql
\i locals.sql
do language plpgsql $$
declare
DBNAME 	varchar(128);
DBUSER 	varchar(128);
DBPASS 	varchar(128);
DBDIR  	varchar(128);
TMPDIR	varchar(128);
PGVER  integer;
EPASS   varchar(128);
str text := '';
begin
	
	DBNAME := current_setting('local.dbname');
	DBUSER := current_setting('local.dbuser');
	DBPASS := current_setting('local.dbpass');
	DBDIR  := current_setting('local.dbdir' );
	TMPDIR := current_setting('local.tempdir' );
    PGVER  := (split_part(current_setting('local.pgversion'), '.', 1))::int;
	EPASS  := 'md5'||md5(DBPASS||DBUSER);

	if ( current_setting('local.passport') = '%%PASSPORT%%' ) then
		set local.passport 	= '';
	end if;
	

	if not exists (select 1 from pg_roles where rolname = DBUSER) then
		if PGVER > 12 then	
		str := str || E' create role '||DBUSER||' with nosuperuser nocreatedb nocreaterole login password '''||trim(DBPASS)||'''; ';
		--execute str; 
		else
		str := str || E' create role '||DBUSER||' with nosuperuser nocreatedb nocreaterole login encrypted password '''||trim(EPASS)||'''; ';	
		end if;			
	end if;

	if not exists (select 1 from pg_database where datname = DBNAME) then
		str := str || E' create database '||DBNAME||' with owner '||DBUSER||' encoding ''UTF8'' template template0;'
		return;
	end if;
	
	EXECUTE format('copy ( select %L ) to %L (format text);',str,TMPDIR||'/_database.sql');

end;
$$;

commit;

\cd :_TMP
\i _database.sql

\cd :_DIR
\c :_DBNAME 

\i globals.psql
\i langs.psql
\i locals.sql

start transaction;

\i contrib.local.sql
\i contrib.sql
\i grants.sql

commit;

\setenv PGPASSWORD :_DBPASS
\c :_DBNAME :_DBUSER 

start transaction;

\i globals.psql
\i locals.sql
\i updates.sql

commit;

start transaction;

\i globals.psql
\i locals.sql
\i ./structure/schemas.sql
\i ./structure/types.sql
\i ./structure/structure.sql
\i finalize.sql

commit;





