create table if not exists fb.detections (
    jobid uuid,
    frameid bigint not null,
    detector varchar(128),
    wtime timestamptz not null default now(),
    rect box,
    hash bytea,
    attr jsonb
);


alter table fb.detections alter column wtime set storage plain;
alter table fb.detections alter column detector set storage plain;
alter table fb.detections alter column rect set storage plain;

DO $$
BEGIN
     IF to_regclass('fb.i_detections_jobid') IS NULL THEN
         CREATE INDEX i_detections_jobid ON fb.detections USING btree (jobid);
     END IF;
     IF to_regclass('fb.i_detections_frameid') IS NULL THEN
         CREATE INDEX i_detections_frameid ON fb.detections USING btree (frameid);
     END IF;
     IF to_regclass('fb.i_detections_wtime') IS NULL THEN
         CREATE INDEX i_detections_wtime ON fb.detections USING btree (wtime);
     END IF;
     IF to_regclass('fb.i_detections_rect') IS NULL THEN
         CREATE INDEX i_detections_rect ON fb.detections USING gist (rect);
     END IF;
END $$;


