create table if not exists fb.frames (
    id bigserial primary key,
    ctime timestamptz not null default now(),
    wtime timestamptz not null default now(),
    frame varchar(512) default '',
    film varchar(512) default '',
    filmts bigint default 0,
    owner varchar(128)
);

alter table fb.frames alter column ctime set storage plain;
alter table fb.frames alter column wtime set storage plain;
alter table fb.frames alter column frame set storage plain;
alter table fb.frames alter column film set storage plain;
alter table fb.frames alter column filmts set storage plain;
alter table fb.frames alter column owner set storage plain;

DO $$
BEGIN
IF to_regclass('fb.i_frames_id') IS NULL THEN
    create index i_frames_id on fb.frames using btree(id);
END IF;
IF to_regclass('fb.i_frames_source') IS NULL THEN
    create unique index i_frames_source on fb.frames (frame,film,filmts);
END IF;
END$$;


