CREATE or replace FUNCTION lib.imageinfo(i_media bytea) RETURNS json 
    LANGUAGE plpython3u
    AS $$
import cStringIO
import json

from PIL import Image

try:
    ims = Image.open(cStringIO.StringIO(i_media))
except:
    return None

res = dict()
try:
    res['size'] = ims.size
    res['bbox'] = ims.getbbox()
    res['extrema'] = ims.getextrema()
    res['format'] = ims.format
    res['mode'] = ims.mode
    res['extra'] = ims.info
except:
    return None
return json.dumps(res)		
$$;
