create or replace function lib.jstrip( obj json ) returns json as
$$
import json
def _do(ob):
    if isinstance(ob,dict): return _do_dict(ob)
    if isinstance(ob,list): return _do_list(ob)
    return ob    
def _do_list(ob):
    return [_do(x) for x in ob if x is not None and x != [] and x != {}]
def _do_dict(ob):
    return {k: _do(v) for k, v in ob.items()
        if v is not None and v != [] and v != {}}
return json.dumps(_do(json.loads(obj))) if obj is not None and obj != "" and obj != '[]' and obj != '{}' else None
$$ language plpython3u;

create or replace function lib.jstripb( obj jsonb ) returns jsonb as $$
    select lib.jstrip($1::json)::jsonb;
$$ language sql;

