delete from public.templates_table;
insert into public.templates_table (template,colname,colpath,coltype) values
     ('speedestimate','lane','{measurements,0,waypoints,best,location,lane}','text')
    ,('speedestimate','time','{time}','timestamptz::time::text')
    ,('index@overspeed:spot-speed','speedlimit','{evidence,detector,rule,limits,speed-limit}','integer')
    ,('index@overspeed:spot-speed','overspeed','{evidence,measurements,overspeed,radar}','integer')
    ,('index@overspeed:section-speed','speedlimit','{evidence,detector,rule,limits,speed-limit}','real::integer')
    ,('index@overspeed:section-speed','overspeed','{evidence,measurements,section-overspeed}','real::integer')
    ,('index@stopviolation:parking','time','{evidence,measurements,time}','integer')
    ,('index@wanted:wanted','list','{evidence,args,list-id}','text')
    ,('index@wanted:wanted','alarm','{evidence,args,alarm-color}','integer')
    ,('index@person:person-transit','hashalgo','{measurements,0,waypoints,best,descriptors,0,info,format}','text')
    ,('index@person:person-transit','hashsize','{measurements,0,waypoints,best,descriptors,0,info,size}','integer')

;

delete from public.templates_object;
insert into public.templates_object ( template, pattern ) values
     ('listitem','
        {
            "ts-order": "#{scrollid}",
            "db-order": "#{id}",
            "event":{
                "type": "#{event,type}",
                "time": "#{event,time}",
                "uuid": "#{event,uuid}",
                "measurements": [ "#{event,measurements,0,uuid}" ],
                "origin": "#{event,origin,uuid}",
                "origin-name": "#{event,origin,name}",
                "geolocation": "#{event,origin,geolocation}",
                "location": {
                    "place": "#{event,measurements,0,waypoints,best,location,place}",
                    "lane": "#{event,measurements,0,waypoints,best,location,lane}"
                },
                "vehicle": {
                    "position": {
                        "forward": "#{event,measurements,0,waypoints,best,vehicle,position,forward}",
                        "left": "#{event,measurements,0,waypoints,best,vehicle,position,left}"
                    },
                    "make": "#{event,measurements,0,waypoints,best,vehicle,type,make}",
                    "model": "#{event,measurements,0,waypoints,best,vehicle,type,model}",
                    "class": "#{event,measurements,0,waypoints,best,vehicle,type,info,0,class}",
                    "plate": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,text,ucode}",
                    "plate-country": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,type,country}",
                    "plate-weight": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,weight}",
                    "spot-speed": "#{event,measurements,0,waypoints,best,vehicle,spot-speed,main,measured}",
                    "dir": "#{event,measurements,0,waypoints,best,vehicle,dir}",
                    "dir-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-avg}",
                    "dir-alias": "#{event,measurements,0,waypoints,best,vehicle,dir-alias}",
                    "dir-alias-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-alias-avg}"
                },
                "alarms": "#{event,alarms}"
            },
            "dist":{
                "args":  "#{dist,selected,args}",
                "thumb": "#{dist,selected,thumb}",
                "plate": "#{dist,selected,plate}",
                "vehicle": "#{dist,selected,vehicle}",
                "scene": "#{dist,selected,scene}"
            }
        }
    '),
     ('listitem@controlviolation:wrong-way','
        {
            "ts-order": "#{scrollid}",
            "db-order": "#{id}",
            "event":{
                "type": "#{event,type}",
                "time": "#{event,time}",
                "uuid": "#{event,uuid}",
                "measurements": [ "#{event,measurements,0,uuid}" ],
                "origin": "#{event,origin,uuid}",
                "origin-name": "#{event,origin,name}",
                "geolocation": "#{event,origin,geolocation}",
                "location": {
                    "place": "#{event,measurements,0,waypoints,best,location,place}",
                    "lane": "#{event,measurements,0,waypoints,best,location,lane}"
                },
                "vehicle": {
                    "position": {
                        "forward": "#{event,measurements,0,waypoints,best,vehicle,position,forward}",
                        "left": "#{event,measurements,0,waypoints,best,vehicle,position,left}"
                    },
                    "make": "#{event,measurements,0,waypoints,best,vehicle,type,make}",
                    "model": "#{event,measurements,0,waypoints,best,vehicle,type,model}",
                    "class": "#{event,measurements,0,waypoints,best,vehicle,type,info,0,class}",
                    "plate": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,text,ucode}",
                    "plate-country": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,type,country}",
                    "plate-weight": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,weight}",
                    "spot-speed": "#{event,measurements,0,waypoints,best,vehicle,spot-speed,main,measured}",
                    "dir": "#{event,measurements,0,waypoints,best,vehicle,dir}",
                    "dir-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-avg}",
                    "dir-alias-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-alias-avg}",
                    "dir-alias": "#{event,measurements,0,waypoints,best,vehicle,dir-alias}"
                },
                "alarms": "#{event,alarms}"
            },
            "dist":{
                "args":  "#{dist,selected,args}",
                "thumb": "#{dist,selected,thumb}",
                "plate": "#{dist,selected,plate}",
                "vehicle": "#{dist,selected,vehicle}",
                "scene": "#{dist,selected,scene}"
            }
        }
    '),
    ('listitem@stopviolation:bus-lane','
        {
            "ts-order": "#{scrollid}",
            "db-order": "#{id}",
            "event":{
                "type": "#{event,type}",
                "time": "#{event,time}",
                "uuid": "#{event,uuid}",
                "measurements": [ "#{event,measurements,0,uuid}" ],
                "origin": "#{event,origin,uuid}",
                "origin-name": "#{event,origin,name}",
                "geolocation": "#{event,origin,geolocation}",
                "location": {
                    "place": "#{event,evidence,measurements,waypoints,best,location,place}",
                    "lane": "#{event,evidence,measurements,waypoints,best,location,lane}"
                },
                "vehicle": {
                    "position": {
                        "forward": "#{event,measurements,0,waypoints,best,vehicle,position,forward}",
                        "left": "#{event,measurements,0,waypoints,best,vehicle,position,left}"
                    },
                    "make": "#{event,measurements,0,waypoints,best,vehicle,type,make}",
                    "model": "#{event,measurements,0,waypoints,best,vehicle,type,model}",
                    "class": "#{event,measurements,0,waypoints,best,vehicle,type,info,0,class}",
                    "plate": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,text,ucode}",
                    "plate-country": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,type,country}",
                    "plate-weight": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,weight}",
                    "spot-speed": "#{event,measurements,0,waypoints,best,vehicle,spot-speed,main,measured}",
                    "dir": "#{event,evidence,measurements,waypoints,best,vehicle,dir}",
                    "dir-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-avg}",
                    "dir-alias-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-alias-avg}",
                    "dir-alias": "#{event,evidence,measurements,waypoints,best,vehicle,dir-alias}"
                },
                "alarms": "#{event,alarms}"
            },
            "dist":{
                "args":  "#{dist,selected,args}",
                "thumb": "#{dist,selected,thumb}",
                "plate": "#{dist,selected,plate}",
                "vehicle": "#{dist,selected,vehicle}",
                "scene": "#{dist,selected,scene}"
            }
        }
    '),
    ('listitem@controlviolation:red-light','
        {
            "ts-order": "#{scrollid}",
            "db-order": "#{id}",
            "event":{
                "type": "#{event,type}",
                "time": "#{event,time}",
                "uuid": "#{event,uuid}",
                "measurements": [ "#{event,measurements,0,uuid}" ],
                "origin": "#{event,origin,uuid}",
                "origin-name": "#{event,origin,name}",
                "geolocation": "#{event,origin,geolocation}",
                "location": {
                    "place": "#{event,measurements,0,waypoints,best,location,place}",
                    "lane": "#{event,measurements,0,waypoints,best,location,lane}"
                },
                "vehicle": {
                    "position": {
                        "forward": "#{event,measurements,0,waypoints,best,vehicle,position,forward}",
                        "left": "#{event,measurements,0,waypoints,best,vehicle,position,left}"
                    },
                    "make": "#{event,measurements,0,waypoints,best,vehicle,type,make}",
                    "model": "#{event,measurements,0,waypoints,best,vehicle,type,model}",
                    "class": "#{event,measurements,0,waypoints,best,vehicle,type,info,0,class}",
                    "plate": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,text,ucode}",
                    "plate-country": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,type,country}",
                    "plate-weight": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,weight}",
                    "spot-speed": "#{event,measurements,0,waypoints,best,vehicle,spot-speed,main,measured}",
                    "dir": "#{event,measurements,0,waypoints,best,vehicle,dir}",
                    "dir-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-avg}",
                    "dir-alias-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-alias-avg}",
                    "dir-alias": "#{event,measurements,0,waypoints,best,vehicle,dir-alias}"
                },
                "alarms": "#{event,alarms}"
            },
            "dist":{
                "args":  "#{dist,selected,args}",
                "thumb": "#{dist,selected,thumb}",
                "plate": "#{dist,selected,plate}",
                "vehicle": "#{dist,selected,vehicle}",
                "scene": "#{dist,selected,scene}"
            }
        }
    '),
     ('listitem@overspeed:spot-speed','
        {
            "ts-order": "#{scrollid}",
            "db-order": "#{id}",
            "event":{
                "type": "#{event,type}",
                "time": "#{event,time}",
                "uuid": "#{event,uuid}",
                "measurements": [ "#{event,measurements,0,uuid}" ],
                "origin": "#{event,origin,uuid}",
                "origin-name": "#{event,origin,name}",
                "geolocation": "#{event,origin,geolocation}",
                "location": {
                    "place": "#{event,evidence,measurements,waypoints,best,location,place}",
                    "lane": "#{event,evidence,measurements,waypoints,best,location,lane}"
                },
                "vehicle": {
                    "position": {
                        "forward": "#{event,measurements,0,waypoints,best,vehicle,position,forward}",
                        "left": "#{event,measurements,0,waypoints,best,vehicle,position,left}"
                    },
                    "make": "#{event,measurements,0,waypoints,best,vehicle,type,make}",
                    "model": "#{event,measurements,0,waypoints,best,vehicle,type,model}",
                    "class": "#{event,measurements,0,waypoints,best,vehicle,type,info,0,class}",
                    "plate": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,text,ucode}",
                    "plate-country": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,type,country}",
                    "plate-weight": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,weight}",
                    "spot-speed": "#{event,evidence,measurements,speed,main,measured}",
                    "overspeed": "#{event,evidence,measurements,overspeed,main,measured}",
                    "dir": "#{event,evidence,measurements,waypoints,best,vehicle,dir}",
                    "dir-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-avg}",
                    "dir-alias-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-alias-avg}",
                    "dir-alias": "#{event,evidence,measurements,waypoints,best,vehicle,dir-alias}"
                },
                "alarms": "#{event,alarms}"
            },
            "dist":{
                "args":  "#{dist,selected,args}",
                "thumb": "#{dist,selected,thumb}",
                "plate": "#{dist,selected,plate}",
                "vehicle": "#{dist,selected,vehicle}",
                "scene": "#{dist,selected,scene}"
            }
        }
    '),
     ('listitem@overspeed:section-speed','
        {
            "ts-order": "#{scrollid}",
            "db-order": "#{id}",
            "event":{
                "type": "#{event,type}",
                "time": "#{event,time}",
                "uuid": "#{event,uuid}",
                "measurements": [ "#{event,measurements,0,uuid}", "#{event,measurements,1,uuid}" ],
                "origin": "#{event,origin,uuid}",
                "origin-name": "#{event,origin,name}",
                "geolocation": "#{event,origin,geolocation}",
                "location": {
                    "place": "#{event,measurements,0,waypoints,best,location,place}",
                    "lane": "#{event,measurements,0,waypoints,best,location,lane}"
                },
                "vehicle": {
                    "position": {
                        "forward": "#{event,measurements,0,waypoints,best,vehicle,position,forward}",
                        "left": "#{event,measurements,0,waypoints,best,vehicle,position,left}"
                    },
                    "make": "#{event,measurements,0,waypoints,best,vehicle,type,make}",
                    "model": "#{event,measurements,0,waypoints,best,vehicle,type,model}",
                    "class": "#{event,measurements,0,waypoints,best,vehicle,type,info,0,class}",
                    "plate": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,text,ucode}",
                    "plate-country": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,type,country}",
                    "plate-weight": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,weight}",
                    "spot-speed": "#{event,evidence,measurements,speed,main,measured}",
                    "section-speed": "#{event,evidence,measurements,section-speed}",
                    "overspeed": "#{event,evidence,measurements,section-overspeed}",
                    "dir": "#{event,measurements,0,waypoints,best,vehicle,dir}",
                    "dir-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-avg}",
                    "dir-alias-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-alias-avg}",
                    "dir-alias": "#{event,measurements,0,waypoints,best,vehicle,dir-alias}"
                },
                "alarms": "#{event,alarms}"
            },
            "dist":{
                "args":  "#{dist,selected,args}",
                "thumb": "#{dist,selected,thumb}",
                "plate": "#{dist,selected,plate}",
                "vehicle": "#{dist,selected,vehicle}",
                "scene": "#{dist,selected,scene}"
            }
        }
    '),
    ('architem','
        {
            "db-order": "#{id}",
            "event":{
                "type": "#{event,type}",
                "time": "#{event,time}",
                "uuid": "#{event,uuid}",
                "measurements": [ "#{event,measurements,0,uuid}" ],
                "origin": "#{event,origin,uuid}",
                "origin-name": "#{event,origin,name}",
                "geolocation": "#{event,origin,geolocation}",
                "location": {
                    "place": "#{event,measurements,0,waypoints,best,location,place}",
                    "lane": "#{event,measurements,0,waypoints,best,location,lane}"
                },
                "vehicle": {
                    "position": {
                        "forward": "#{event,measurements,0,waypoints,best,vehicle,position,forward}",
                        "left": "#{event,measurements,0,waypoints,best,vehicle,position,left}"
                    },
                    "make": "#{event,measurements,0,waypoints,best,vehicle,type,make}",
                    "model": "#{event,measurements,0,waypoints,best,vehicle,type,model}",
                    "class": "#{event,measurements,0,waypoints,best,vehicle,type,info,0,class}",
                    "plate": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,text,ucode}",
                    "plate-country": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,type,country}",
                    "plate-weight": "#{event,measurements,0,waypoints,best,vehicle,license-plates,0,weight}",
                    "spot-speed": "#{event,measurements,0,waypoints,best,vehicle,spot-speed,main,measured}",
                    "dir": "#{event,measurements,0,waypoints,best,vehicle,dir}",
                    "dir-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-avg}",
                    "dir-alias-avg": "#{event,measurements,0,waypoints,best,vehicle,dir-alias-avg}",
                    "dir-alias": "#{event,measurements,0,waypoints,best,vehicle,dir-alias}"
                },
                "alarms": "#{event,alarms}"
            },
            "dist": "#{dist,list}"
        }
    ')
;


