#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# (k) made-on-the-knee-of /dragon, 2017

import eventor
import json, os, sys, time
from datetime import datetime, timedelta
import psycopg2
import psycopg2.extras
import psycopg2.extensions
psycopg2.extensions.register_type(psycopg2.extensions.UNICODE)
psycopg2.extensions.register_type(psycopg2.extensions.UNICODEARRAY)


dbconn = psycopg2.connect( "host='localhost' port=5432 dbname='autocode' user='autocode' password='autocode'" )
dbconn.set_isolation_level(psycopg2.extensions.ISOLATION_LEVEL_AUTOCOMMIT)

dbc = dbconn.cursor(cursor_factory=psycopg2.extras.DictCursor)

n = 1000
tstart = None;

elog = False

if len(sys.argv) > 1:
    if sys.argv[1] == 'back':
        try:
            d = int(sys.argv[2])
            n = int(sys.argv[3])
            tstart = datetime.now() - timedelta(days=d)
            tdelta = timedelta(seconds = 120)
            t = tstart
        except:
            print ("invalid arg, use defaul")
            pass
    else:
        try:
            n = int(sys.argv[1])
        except:
            pass
    
for i in range(n):
    time.sleep(0.1)
    if tstart:
        t = t - tdelta - timedelta(microseconds = eventor._rint(120e6))
    else:    
        t = datetime.now()
    evt = eventor.mkevent(t)
    buf = json.dumps(evt)
    sql = dbc.mogrify( """
        select * from api_event_add(
            json_build_object(
            'flag', 0, 'active', 'true',
            'dist', '{
                "store":"store1",
                "list":[ 
                "0_98962452519387137.jpeg",
                "0_98962452519387138.jpeg", 
                "0_98962452519387136.json"
                ],
                "selected": {
                    "args": "0_98962452519387136.json",
                    "thumb": "0_98962452519387137.jpeg",
                    "plate": "0_98962452519387138.jpeg"
                }
            }'::jsonb,
            'event',
             %s::jsonb )::jsonb); """, [buf])
    if elog:
        with open('./eventlog.sql','a+t') as el:
            el.write(sql)
    dbc.execute(sql)        
    r = dbc.fetchone()
    if r:
        ar = r[2]
        if r[0] == 0:
            print("%d -> %d" % (ar['id'],ar['scrollid']))
        else:
            with open("e-%0d.json","wt") as f:
                json.dump(json.loads(buf),f,indent=4)
            print("ERROR: %s %s " % (r[0],r[1]))
    else:    
        print("FATAL:")


