-- update script for X.X core patch XXXX

do language plpgsql
$_$
declare 
r record;
frommajor 		integer := 4;	-- points to source version
fromminor  		integer := 14;	-- if null then source = destination - (0,0,1)
fromrelease 	integer := 0;	-- optional

tomajor		integer	:= 4;		-- points to destination version
tominor		integer := 15;		-- mandatory
torelease	integer	:= 0;

torevision  varchar := '202301301600';	-- any string (i.e. timestamp)

begin

if not exists (select * from information_schema.columns where table_schema = 'core' and table_name = 'version' and column_name = 'release') then return; end if;
if tomajor isnull or tominor isnull or torelease isnull then raise exception 'Invalid upper version'; return; end if;	
if frommajor isnull or fromminor isnull or fromrelease isnull then frommajor := 0; fromminor := 0; fromrelease := 1; end if;	

select into r
	major,minor,release,
	lib.intversion(major,minor,release) as curver, 
	lib.intversion(frommajor,fromminor,fromrelease) as fromver, 
	lib.intversion(tomajor,tominor,torelease) as tover,
    exists ( select 1 from core.version where revision = torevision limit 1) as dup
from core.version where module = 'core' order by curver desc limit 1;
if not found then return; end if;

if r.curver >= r.fromver and r.curver < r.tover and not r.dup then

-- BEGIN PATCH

update eventcache ec set event = jsonb_build_object('db-order',ec.event->'db-order','event',ec2.event->'event','dist',ec.event->'dist') from eventcache ec2 where ec.template = 'architem' and ec2.template = 'listitem' and ec.id = ec2.id;

-- END PATCH


	insert into core.version (module,major,minor,release,revision) values('core',tomajor,tominor,torelease,torevision);
end if;
end;
$_$;
